
#include "Drv_DcModule.h"
#include "Drv_MCP2515.h"
#include "Memory.h"
#include "Drv_SmartAllocation.h"
#include "Global.h"


StructDcModuleGroup DcModuleGroup[] =
{
	{
		2, 0, 
		{
			1, 0, 0, 0, 2, 0, 0, 0
		},
		Invalid, 0, 0
	},
	{
		1, 0, 
		{
			3, 0, 0, 0, 0, 0, 0, 0
		},
		Invalid, 0, 0
	},
	{
		2, 0, 
		{
			4, 0, 0, 0, 5, 0, 0, 0
		},
		Invalid, 0, 0
	},
	{
		1, 0, 
		{
			6, 0, 0, 0, 0, 0, 0, 0
		},
		Invalid, 0, 0
	},
};


static u8		DcModuleGroupSize = sizeof(DcModuleGroup) / sizeof(DcModuleGroup[0]);


extern StructDcModuleManage DcModuleManage;
StructDcModuleManage DcModuleManage_A;
extern StructDcModuleManage DcModuleManage_B;
StructDcModuleManage DcModuleManage_All;

extern StructDcModuleCtrl DcModuleCtrl;
StructDcModuleCtrl DcModuleCtrl_A;
extern StructDcModuleCtrl DcModuleCtrl_B;

extern u8 DcModuleSendMsg(StructDcModuleSend * pMsg);

extern StructDcModuleStatus DcModuleStatus[64];
extern StructDcModuleStatus DcModuleStatus_B[64];

extern void DcModuleCanInit(void);

extern osMessageQId	DcModeMsg;

void DcModuleManageProcess_SmartAllocation(void)
{
	static u32		CheckTick = 0;
	u8				addr = 0;

	u8				i, j;
	long long		Flag;
	u8				Count, Count_A, Count_B;
	u32 			Currt, Currt_A, Currt_B;
	u32 			Volt, Volt_A, Volt_B;
	u8				status;
	
	
	static u8 StatusGetCnt = 0;
	StructDcModuleSend DataSend;
	
        static u32		StaticTick = 0;
	if(StaticTick == 0) 
		StaticTick = GetSystemTick();

	if((GetSystemTick() -StaticTick) > 1000){
		StaticTick			= GetSystemTick();
	   for(i=0;i<DcModuleGroupSize;i++){
		for(j=0;j<DcModuleGroup[i].num;j++){
			addr = DcModuleGroup[i].modules[j].addr;
			
			DataSend.Id = 0x1307C080 + addr;
			DataSend.Len = 8;
			DataSend.Data[0] = 0x01;
			DataSend.Data[1] = 0x00;
			DataSend.Data[2] = 0x00;
			DataSend.Data[3] = 0x00;
			DataSend.Data[4] = 0x00;
			DataSend.Data[5] = 0x00;
			DataSend.Data[6] = 0x00;
			DataSend.Data[7] = 0x00;
			//DcModuleSendMsg(&DataSend);
			//放入队列
			if (pdTRUE != xQueueSend(DcModeMsg, &DataSend, 0))
			{
				osDelay(10);
				
			}
		}
		
		}
		}


	if ((GetSystemTick() -CheckTick) < 100)
		return;

	CheckTick			= GetSystemTick();

	Flag				= 1;
	Count				= 0;

	for (i = 0; i < 64; i++)
	{
		if (Flag & DcModuleManage_All.OnlineFlag)
		{
			if ((GetSystemTick() -DcModuleStatus[i].RecvTime) > 8000)
			{
				DcModuleManage_All.OnlineFlag &= ~Flag;
				DcModuleManage_All.ValidFlag &= ~Flag;
			}
			else 
			{
				if (0x0002 != (DcModuleStatus[i].State & 0x0002))
				{
					DcModuleManage_All.ValidFlag |= Flag;
					Count++;
				}
			}
		}

		Flag				= Flag << 1;
	}

	DcModuleManage_All.ValidNum = Count;

	for (i = 0; i < DcModuleGroupSize; i++)
	{
		Currt				= 0;
		Volt				= 0;
		Count				= 0;

		for (j = 0; j < DcModuleGroup[i].num; j++)
		{
			addr				= DcModuleGroup[i].modules[j].addr;
			Flag				= addr << 1;

			if (Flag & DcModuleManage_All.ValidFlag)
			{
				Currt				+= DcModuleStatus[addr].Currt;
				Volt				+= DcModuleStatus[addr].Volt;
				Count++;

				DcModuleGroup[i].modules[j].status = Valid;
				DcModuleGroup[i].modules[j].Voltage = DcModuleStatus[addr].Volt;
				DcModuleGroup[i].modules[j].Current = DcModuleStatus[addr].Currt;
			}
			else 
			{
				DcModuleGroup[i].modules[j].status = Invalid;

			}
		}

		DcModuleGroup[i].ValidNum = Count;
		DcModuleGroup[i].Voltage = Volt / Count;
		DcModuleGroup[i].Current = Currt;
	}

	for (i = 0; i < DcModuleGroupSize; i++)
	{
		status				= DcModuleGroup[i].modules[0].status;

		if (DcModuleGroup[i].num != DcModuleGroup[i].ValidNum)
		{

		}

		if (DcModuleGroup[i].num > 1)
		{
			if (status != Valid)
			{
				if (DcModuleGroup[i].modules[1].status != Valid)
				{
					DcModuleGroup[i].status = Invalid;

				}
			}
		}
		else 
		{
			if (status != Valid)
			{
				DcModuleGroup[i].status = Invalid;
			}

		}
	}

	Currt				= 0;
	Currt_A 			= 0;
	Currt_B 			= 0;
	Volt				= 0;
	Volt_A				= 0;
	Volt_B				= 0;
	Count				= 0;
	Count_A 			= 0;
	Count_B 			= 0;

	for (i = 0; i < DcModuleGroupSize; i++)
	{
		if (DcModuleGroup[i].status == Valid)
		{
			Volt				+= DcModuleGroup[i].Voltage;
			Currt				+= DcModuleGroup[i].Current;
			Count				+= DcModuleGroup[i].ValidNum;
		}
		else if (DcModuleGroup[i].status == Hold_A)
		{
			Volt_A				+= DcModuleGroup[i].Voltage;
			Currt_A 			+= DcModuleGroup[i].Current;
			Count_A 			+= DcModuleGroup[i].ValidNum;
		}
		else if (DcModuleGroup[i].status == Hold_B)
		{
			Volt_B				+= DcModuleGroup[i].Voltage;
			Currt_B 			+= DcModuleGroup[i].Current;
			Count_B 			+= DcModuleGroup[i].ValidNum;
		}
	}

	DcModuleCtrl.ActualCurrt = Currt;
	DcModuleCtrl.ActualVolt = Volt;
	DcModuleCtrl_A.ActualCurrt = Currt_A;
	DcModuleCtrl_A.ActualVolt = Volt_A;
	DcModuleCtrl_B.ActualCurrt = Currt_B;
	DcModuleCtrl_B.ActualVolt = Volt_B;

	DcModuleManage.ValidNum = Count;
	DcModuleManage_A.ValidNum = Count_A;
	DcModuleManage_B.ValidNum = Count_B;

	//if (0 == DcModuleManage_All.OnlineFlag)
	//	DcModuleCanInit();
}



void DcModuleCtrlProcess_SmartAllocation(void)
{
	static u32		CtrlTick = 0;
	static u8		LastFlag_A = 0;
	static u8		LastFlag_B = 0;

	static StructDcModuleUsedStatus status[4] =
	{
		Invalid, Invalid, Invalid, Invalid
	};

	StructDcModuleSend DataSend;
	u32 			Temp;
	u8				addr;

	Temp				= 0;

	for (u8 i = 0; i < DcModuleGroupSize; i++)
	{
		if (status[i] != DcModuleGroup[i].status)
		{

			if (DcModuleGroup[i].status == Valid)
			{
				//切换继电器
				//关机
				if (status[i] == Hold_A)
				{
					DcModuleManage_A.SetVolt = DcModuleAbility.MinVolt * 100;
					DcModuleManage_A.SetCurrt = DcModuleAbility.MinCurrt * 100;
					DcModuleManage_A.Cmd = 0xAA;	//关机
				}
				else if (status[i] == Hold_B)
				{
					DcModuleManage_B.SetVolt = DcModuleAbility.MinVolt * 100;
					DcModuleManage_B.SetCurrt = DcModuleAbility.MinCurrt * 100;
					DcModuleManage_B.Cmd = 0xAA;	//关机
				}

				for (u8 j = 0; j < DcModuleGroup[i].num; j++)
				{
					addr				= DcModuleGroup[i].modules[j].addr;

					DataSend.Id 		= 0x1307C080 + addr;
					DataSend.Len		= 8;
					DataSend.Data[0]	= 0x00;
					DataSend.Data[1]	= 0x00;
					Temp				= DcModuleAbility.MinCurrt * 100;
					DataSend.Data[2]	= (u8) (Temp >> 8);
					DataSend.Data[3]	= (u8) (Temp >> 0);
					Temp				= DcModuleAbility.MinVolt * 100;
					DataSend.Data[4]	= (u8) (Temp >> 24);
					DataSend.Data[5]	= (u8) (Temp >> 16);
					DataSend.Data[6]	= (u8) (Temp >> 8);
					DataSend.Data[7]	= (u8) (Temp >> 0);

					//放入队列
					DataSend.Id 		= 0x1307C080 + addr;
					DataSend.Len		= 8;
					DataSend.Data[0]	= 0x02;
					DataSend.Data[1]	= 0x00;
					DataSend.Data[2]	= 0x00;
					DataSend.Data[3]	= 0x00;
					DataSend.Data[4]	= 0x00;
					DataSend.Data[5]	= 0x00;
					DataSend.Data[6]	= 0x00;
					DataSend.Data[7]	= 0xAA; 	//关机

					//放入队列
				}
			}
			else if (DcModuleGroup[i].status == Hold_A)
			{
				//切换继电器
			}
			else if (DcModuleGroup[i].status == Hold_B)
			{
				//切换继电器
			}
			else 
			{
				//切换继电器
			}

			status[i]			= DcModuleGroup[i].status;
		}

	}

	if (LastFlag_A != DcModuleCtrl_A.CtrlFlag)
	{
		LastFlag_A			= DcModuleCtrl_A.CtrlFlag;
		Temp++;
	}

	if (LastFlag_B != DcModuleCtrl_B.CtrlFlag)
	{
		LastFlag_B			= DcModuleCtrl_B.CtrlFlag;
		Temp++;
	}

	if ((GetSystemTick() -CtrlTick) > 100)
	{
		CtrlTick			= GetSystemTick();
		Temp++;
	}

	if (0 == Temp)
		return;

	if (DcModuleCtrl_A.CtrlFlag)
	{
		if (DcModuleCtrl_A.NeedVolt > DcModuleAbility.MaxVolt)
			DcModuleManage_A.SetVolt = (DcModuleAbility.MaxVolt * 100);
		else if (DcModuleCtrl_A.NeedVolt > DcModuleAbility.MinVolt)
			DcModuleManage_A.SetVolt = (DcModuleCtrl_A.NeedVolt * 100);
		else 
			DcModuleManage_A.SetVolt = (DcModuleAbility.MinVolt * 100);

		if (DcModuleManage_A.ValidNum)
		{
			Temp				= (DcModuleCtrl_A.NeedCurrt * 100) / DcModuleManage_A.ValidNum;

			if ((DcModuleCtrl_A.NeedCurrt * 100) % DcModuleManage_A.ValidNum)
				Temp++;
		}
		else 
			Temp = DcModuleManage_A.SetCurrt;

		if (Temp > (DcModuleAbility.MaxCurrt * 100))
			Temp = (DcModuleAbility.MaxCurrt * 100);
		else if (Temp < (DcModuleAbility.MinCurrt * 100))
			Temp = (DcModuleAbility.MinCurrt * 100);

		if (Temp <= DcModuleManage_A.SetCurrt)
			DcModuleManage_A.SetCurrt = Temp;
		else 
		{
			DcModuleManage_A.SetCurrt += 500;

			if (DcModuleManage_A.SetCurrt >= Temp)
				DcModuleManage_A.SetCurrt = Temp;
		}

		if (DcModuleManage_A.SetCurrt > (DcModuleAbility.MaxCurrt * 100))
			DcModuleManage_A.SetCurrt = (DcModuleAbility.MaxCurrt * 100);
		else if (DcModuleManage_A.SetCurrt < (DcModuleAbility.MinCurrt * 100))
			DcModuleManage_A.SetCurrt = (DcModuleAbility.MinCurrt * 100);

		for (u8 i = 0; i < DcModuleGroupSize; i++)
		{
			if (DcModuleGroup[i].status != Hold_A)
				continue;

			for (u8 j = 0; j < DcModuleGroup[i].num; j++)
			{
				addr				= DcModuleGroup[i].modules[j].addr;

				DataSend.Id 		= 0x1307C080 + addr;
				DataSend.Len		= 8;
				DataSend.Data[0]	= 0x00;
				DataSend.Data[1]	= 0x00;

				Temp				= DcModuleManage_A.SetCurrt;
				DataSend.Data[2]	= (u8) (Temp >> 8);
				DataSend.Data[3]	= (u8) (Temp >> 0);
				Temp				= DcModuleManage_A.SetVolt;
				DataSend.Data[4]	= (u8) (Temp >> 24);
				DataSend.Data[5]	= (u8) (Temp >> 16);
				DataSend.Data[6]	= (u8) (Temp >> 8);
				DataSend.Data[7]	= (u8) (Temp >> 0);

				//放入队列
				DcModuleManage_A.Cmd = 0x55;		//开机
				DataSend.Id 		= 0x1307C080 + addr;
				DataSend.Len		= 8;
				DataSend.Data[0]	= 0x02;
				DataSend.Data[1]	= 0x00;
				DataSend.Data[2]	= 0x00;
				DataSend.Data[3]	= 0x00;
				DataSend.Data[4]	= 0x00;
				DataSend.Data[5]	= 0x00;
				DataSend.Data[6]	= 0x00;
				DataSend.Data[7]	= DcModuleManage_A.Cmd;

				//放入队列
			}
		}
	}
	else 
	{

	}

	if (DcModuleCtrl_B.CtrlFlag)
	{
		if (DcModuleCtrl_B.NeedVolt > DcModuleAbility.MaxVolt)
			DcModuleManage_B.SetVolt = (DcModuleAbility.MaxVolt * 100);
		else if (DcModuleCtrl_B.NeedVolt > DcModuleAbility.MinVolt)
			DcModuleManage_B.SetVolt = (DcModuleCtrl_B.NeedVolt * 100);
		else 
			DcModuleManage_B.SetVolt = (DcModuleAbility.MinVolt * 100);

		if (DcModuleManage_B.ValidNum)
		{
			Temp				= (DcModuleCtrl_B.NeedCurrt * 100) / DcModuleManage_B.ValidNum;

			if ((DcModuleCtrl_B.NeedCurrt * 100) % DcModuleManage_B.ValidNum)
				Temp++;
		}
		else 
			Temp = DcModuleManage_B.SetCurrt;

		if (Temp > (DcModuleAbility.MaxCurrt * 100))
			Temp = (DcModuleAbility.MaxCurrt * 100);
		else if (Temp < (DcModuleAbility.MinCurrt * 100))
			Temp = (DcModuleAbility.MinCurrt * 100);

		if (Temp <= DcModuleManage_B.SetCurrt)
			DcModuleManage_B.SetCurrt = Temp;
		else 
		{
			DcModuleManage_B.SetCurrt += 500;

			if (DcModuleManage_B.SetCurrt >= Temp)
				DcModuleManage_B.SetCurrt = Temp;
		}

		if (DcModuleManage_B.SetCurrt > (DcModuleAbility.MaxCurrt * 100))
			DcModuleManage_B.SetCurrt = (DcModuleAbility.MaxCurrt * 100);
		else if (DcModuleManage_B.SetCurrt < (DcModuleAbility.MinCurrt * 100))
			DcModuleManage_B.SetCurrt = (DcModuleAbility.MinCurrt * 100);

		for (u8 i = 0; i < DcModuleGroupSize; i++)
		{
			if (DcModuleGroup[i].status != Hold_B)
				continue;

			for (u8 j = 0; j < DcModuleGroup[i].num; j++)
			{
				addr				= DcModuleGroup[i].modules[j].addr;

				DataSend.Id 		= 0x1307C080 + addr;
				DataSend.Len		= 8;
				DataSend.Data[0]	= 0x00;
				DataSend.Data[1]	= 0x00;

				Temp				= DcModuleManage_B.SetCurrt;
				DataSend.Data[2]	= (u8) (Temp >> 8);
				DataSend.Data[3]	= (u8) (Temp >> 0);
				Temp				= DcModuleManage_B.SetVolt;
				DataSend.Data[4]	= (u8) (Temp >> 24);
				DataSend.Data[5]	= (u8) (Temp >> 16);
				DataSend.Data[6]	= (u8) (Temp >> 8);
				DataSend.Data[7]	= (u8) (Temp >> 0);

				//放入队列
				DcModuleManage_B.Cmd = 0x55;		//开机
				DataSend.Id 		= 0x1307C080 + addr;
				DataSend.Len		= 8;
				DataSend.Data[0]	= 0x02;
				DataSend.Data[1]	= 0x00;
				DataSend.Data[2]	= 0x00;
				DataSend.Data[3]	= 0x00;
				DataSend.Data[4]	= 0x00;
				DataSend.Data[5]	= 0x00;
				DataSend.Data[6]	= 0x00;
				DataSend.Data[7]	= DcModuleManage_B.Cmd;

				//放入队列
			}
		}

	}
	else 
	{


	}
}


